<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Driver &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../../_static/doctools.js?v=888ff710"></script>
        <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Dynamics_RegularDriving" href="dynamics_regular_driving.html" />
    <link rel="prev" title="Algorithm_Longitudinal" href="algorithm_longitudinal.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            openPASS
              <img src="../../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../50_scenario_simulation.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../20_components.html">Component View</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../20_components.html#components-in-depth">Components in Depth</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="algorithm_lateral.html">Algorithm_Lateral</a></li>
<li class="toctree-l4"><a class="reference internal" href="algorithm_longitudinal.html">Algorithm_Longitudinal</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_regular_driving.html">Dynamics_RegularDriving</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_scenario.html">Dynamics_Scenario</a></li>
<li class="toctree-l4"><a class="reference internal" href="sensor_driver.html">Sensor_Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="spawner.html">Spawner</a></li>
<li class="toctree-l4"><a class="reference internal" href="vehicle.html">VehicleComponents</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../50_scenario_simulation.html">Simulator</a></li>
          <li class="breadcrumb-item"><a href="../20_components.html">Component View</a></li>
      <li class="breadcrumb-item active">Driver</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/user_guide/sim_user_guide/components/driver.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="driver">
<span id="components-driver"></span><h1>Driver<a class="headerlink" href="#driver" title="Link to this heading"></a></h1>
<section id="algorithmagentfollowingdrivermodel">
<span id="components-agentfollowingdrivermodel"></span><h2>AlgorithmAgentFollowingDriverModel<a class="headerlink" href="#algorithmagentfollowingdrivermodel" title="Link to this heading"></a></h2>
<p>AlgorithmAgentFollowingDriverModel implements a simple driver model for longitudinal and lateral control.</p>
<section id="lateral-control">
<h3>Lateral control<a class="headerlink" href="#lateral-control" title="Link to this heading"></a></h3>
<p>The lateral guidance always keeps the agent in the middle of the lane.</p>
</section>
<section id="longitudinal-control">
<h3>Longitudinal control<a class="headerlink" href="#longitudinal-control" title="Link to this heading"></a></h3>
<p>This driver type works according to the IDM (Intelligent Driver Model) and adapts its velocity to an agent in front and holds
a desired velocity if there’s no front agent available (like adaptive cruise control).</p>
<p>For a simplified version of the model, the Intelligent Driver Model acceleration <img class="math" src="../../../_images/math/d39a46e63ea61f983053165be8919b2d415a242d.png" alt="a_{IDM}"/> is described by the following equation:</p>
<div class="math">
<p><img src="../../../_images/math/e7f5236ae203153f19fa34af90e8fecae306de35.png" alt="a_{IDM} = a_{max} \cdot (1 - (\frac{v_{vehicle}}{v_{wish}})^\delta - (\frac{s^*(v_{vehicle},\Delta v)}{s_{netDistance}})^2)"/></p>
</div><p>with</p>
<div class="math">
<p><img src="../../../_images/math/cb62296f4d905147f13ad49d56a01ac1d209ccc6.png" alt="s^*(v_{vehicle},\Delta v) = s_{0} + v_{vehicle} \cdot T + \frac{v_{vehicle} \cdot \Delta v}{2 \cdot \sqrt{a_{max} \cdot b_{max}}}"/></p>
</div><p>The calculation of <img class="math" src="../../../_images/math/bee30f2cce9bda089aca48016006f43c7a1a00ab.png" alt="\Delta v"/> is done by subtracting the absolute velocity <img class="math" src="../../../_images/math/2daa980935ee71285c83c0221af428ae007e42af.png" alt="v_{vehicle}"/> of the own vehicle
from the absolute velocity <img class="math" src="../../../_images/math/bf6a0bfd0f1acb8457a54999f6457d5d55fee769.png" alt="v_{frontAgent}"/> of the front agent:</p>
<div class="math">
<p><img src="../../../_images/math/9369c8636d522b2acde2dec96ebf91a101a7880b.png" alt="\Delta v = v_{vehicle} - v_{frontAgent}"/></p>
</div><p>The acceleration of the vehicle (Intelligent Driver Model acceleration) can be separated into</p>
<ul class="simple">
<li><p>free road term:</p></li>
</ul>
<div class="math">
<p><img src="../../../_images/math/e072f7f8d7e72335c7fa090062c70e71a0842805.png" alt="a_{max} \cdot (1 - (\frac{v_{vehicle}}{v_{wish}})^\delta)"/></p>
</div><ul class="simple">
<li><p>interaction term:</p></li>
</ul>
<div class="math">
<p><img src="../../../_images/math/482a97c02ffe95c0dc931990d691426a039c7bd5.png" alt="-a_{max} \cdot (\frac{s^*(v_{vehicle},\Delta v)}{s_{netDistance}})^2 = -a_{max} \cdot (\frac{s_{0} + v_{vehicle} \cdot T}{s_{netDistance}} + \frac{v_{vehicle} \cdot \Delta v}{2 \cdot \sqrt{a_{max} \cdot b_{max}} \cdot s_{netDistance}})^2"/></p>
</div><p><strong>Free road behavior:</strong> On a free road, the distance to the front agent is huge and the vehicle’s acceleration is controlled
by the free road term, which is approximately equal to <img class="math" src="../../../_images/math/0f3e7b8a9870feac7aadcd7385568b5760e49ef8.png" alt="a_{max}"/> for low velocities and vanishes as <img class="math" src="../../../_images/math/2daa980935ee71285c83c0221af428ae007e42af.png" alt="v_{vehicle}"/> approaches <img class="math" src="../../../_images/math/194fe4ed3f8c6105a0b0069bb3e568e610b81732.png" alt="v_{wish}"/>.
There will be some deviation to the actual vehicle velocity, due to the model not being aware of air drag or engine drag (which might be introduced by
subsequent agent components). AlgorithmAgentFollowingDriverModel just controls its velocity wish.</p>
<p><strong>Behavior at high approaching rates</strong>: For large velocity differences, the interaction term is governed by:</p>
<div class="math">
<p><img src="../../../_images/math/873012ece5b8bcd5e44c0ca3523a67fd31212008.png" alt="-a_{max} \cdot (\frac{v_{vehicle} \cdot \Delta v}{2 \cdot \sqrt{a_{max} \cdot b_{max}} \cdot s_{netDistance}})^2"/></p>
</div><p>This leads to a driving behavior that compensates velocity differences while trying not to brake much harder than the maximum braking deceleration <img class="math" src="../../../_images/math/884d304dc007998a3a56da240fbd29cd58eb85d2.png" alt="b_{max}"/>.</p>
<p><strong>Behavior at small net distances</strong>: For minor velocity differences and small net distances, the interaction term is approximately equal to:</p>
<div class="math">
<p><img src="../../../_images/math/63239f4bf5f49eb26940e815ce19e13555ba57f8.png" alt="-a_{max} \cdot (\frac{s_{0} + v_{vehicle} \cdot T}{s_{netDistance}})^2"/></p>
</div><p>which resembles a simple repulsive force such that small net distances are quickly enlarged towards an equilibrium net distance.</p>
<p>The following table and the DriverProfile snippet describe a whole DriverProfile. Type “AlgorithmAgentFollowingDriverModel” in
the DriverProfile snippet below determines that this set of parameters is active.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Parameter</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Defaults to</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>AlgorithmLateralModule</p></td>
<td><p>String</p></td>
<td></td>
<td><p>Behavior model for the steering wheel angle of the driver</p></td>
<td><p>Required value</p></td>
</tr>
<tr class="row-odd"><td><p>AlgorithmLongitudinalModule</p></td>
<td><p>String</p></td>
<td></td>
<td><p>Behavior model for the accelerator, brake pedal position, and the current gear of the driver</p></td>
<td><p>Required value</p></td>
</tr>
<tr class="row-even"><td><p>VelocityWish: <img class="math" src="../../../_images/math/194fe4ed3f8c6105a0b0069bb3e568e610b81732.png" alt="v_{wish}"/></p></td>
<td><p>Double</p></td>
<td><p>m/s</p></td>
<td><p>Desired speed</p></td>
<td><p><abbr title="120 km/h">33.33 m/s</abbr></p></td>
</tr>
<tr class="row-odd"><td><p>Delta: <img class="math" src="../../../_images/math/652b9d8b65c10aed0fdcdbde47396c879ed5bd33.png" alt="\delta"/></p></td>
<td><p>Double</p></td>
<td></td>
<td><p>Free acceleration exponent characterizing how the acceleration decreases with velocity (1: linear, infinity: constant)</p></td>
<td><p>4.0</p></td>
</tr>
<tr class="row-even"><td><p>TGapWish: <img class="math" src="../../../_images/math/e8dea8254118f111b5fb20895b03528c17566f06.png" alt="T"/></p></td>
<td><p>Double</p></td>
<td><p>s</p></td>
<td><p>Desired time gap between ego and front agent</p></td>
<td><p>1.5 s</p></td>
</tr>
<tr class="row-odd"><td><p>MinDistance: <img class="math" src="../../../_images/math/e2afb14df1b591b66c89c9bdec531773fd46a253.png" alt="s_{0}"/></p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Minimum distance between ego and front (used at slow speeds); Also called jam distance</p></td>
<td><p>2.0 m</p></td>
</tr>
<tr class="row-even"><td><p>MaxAcceleration: <img class="math" src="../../../_images/math/0f3e7b8a9870feac7aadcd7385568b5760e49ef8.png" alt="a_{max}"/></p></td>
<td><p>Double</p></td>
<td><p>m/s²</p></td>
<td><p>Maximum acceleration in satisfactory way, not vehicle possible acceleration</p></td>
<td><p>1.4 m/s²</p></td>
</tr>
<tr class="row-odd"><td><p>MaxDeceleration: <img class="math" src="../../../_images/math/884d304dc007998a3a56da240fbd29cd58eb85d2.png" alt="b_{max}"/></p></td>
<td><p>Double</p></td>
<td><p>m/s²</p></td>
<td><p>Desired deceleration</p></td>
<td><p>2.0 m/s²</p></td>
</tr>
</tbody>
</table>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="nt">&lt;Profile</span><span class="w"> </span><span class="na">Name=</span><span class="s">&quot;Regular&quot;</span><span class="nt">&gt;</span>
<span class="w">  </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Type&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;AlgorithmAgentFollowingDriverModel&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;AlgorithmLateralModule&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Algorithm_LateralAfdm&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;AlgorithmLongitudinalModule&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Algorithm_LongitudinalAfdm&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;VelocityWish&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;36.11&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;Delta&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;4.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;TGapWish&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;1.5&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;MinDistance&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;2.0&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;MaxAcceleration&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;1.4&quot;</span><span class="nt">/&gt;</span>
<span class="w">  </span><span class="nt">&lt;Double</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;MaxDeceleration&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;2.0&quot;</span><span class="nt">/&gt;</span>
<span class="nt">&lt;/Profile&gt;</span>
</pre></div>
</div>
<p>For further information, please refer to:</p>
<p>Treiber, Martin; Hennecke, Ansgar; Helbing, Dirk (2000), “Congested traffic states in empirical observations and microscopic simulations”, Physical Review E, 62 (2): 1805–1824, <a class="reference external" href="https://arxiv.org/pdf/cond-mat/0002177.pdf">https://arxiv.org/pdf/cond-mat/0002177.pdf</a></p>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="algorithm_longitudinal.html" class="btn btn-neutral float-left" title="Algorithm_Longitudinal" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="dynamics_regular_driving.html" class="btn btn-neutral float-right" title="Dynamics_RegularDriving" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>